unit uConnectionModule;

interface

uses
  System.Classes, Data.DB, System.SysUtils, System.StrUtils,

  // Aurelius
  Aurelius.Drivers.Interfaces,
  Aurelius.Comp.Connection, Aurelius.Drivers.UniDac,
  Aurelius.Drivers.Base, Aurelius.Drivers.SQLite,
  Aurelius.Sql.Sqlite, Aurelius.Schema.Sqlite,
  Aurelius.Sql.MSSQL, Aurelius.Schema.MSSQL,
  Aurelius.Sql.PostgreSQL, Aurelius.Schema.PostgreSQL,
  Aurelius.Sql.MySQL, Aurelius.Schema.MySQL,
  Aurelius.Sql.Firebird, Aurelius.Schema.Firebird,
  Aurelius.Sql.Oracle, Aurelius.Schema.Oracle,

  Aurelius.Bind.BaseDataset,
  Aurelius.Bind.Dataset, Aurelius.Drivers.MSSQL;

type
  TDatabaseConnection = class(TDataModule)
    AureliusConnection: TAureliusConnection;
    procedure DataModuleCreate(Sender: TObject);
  private
  public
    class function CreateConnection: IDBConnection;
    class function CreateFactory: IDBConnectionFactory;

    procedure SetConnectionDB();
  end;

  var DatabaseConnection: TDatabaseConnection;

implementation


{$R *.dfm}


procedure TDatabaseConnection.SetConnectionDB;
begin
end;


class function TDatabaseConnection.CreateConnection: IDBConnection;
begin
  Result := DatabaseConnection.AureliusConnection.CreateConnection;
end;


class function TDatabaseConnection.CreateFactory: IDBConnectionFactory;
begin
  Result := TDBConnectionFactory.Create(
    function: IDBConnection
    begin
      Result := CreateConnection;
    end
  );
end;


procedure TDatabaseConnection.DataModuleCreate(Sender: TObject);
begin
  SetConnectionDB;
end;


end.
