unit uCustomer;

interface

uses
  System.Classes, System.StrUtils, System.DateUtils, Generics.Collections,
  Bcl.Validation.Attributes, Bcl.Validation.Classes, Aurelius.Types.Blob,
  Aurelius.Types.Nullable, Aurelius.Types.Proxy, Aurelius.Mapping.Attributes,

  // Entidades
  uUser, uStore,

  System.Variants;


type
  [Entity, Automapping]
  [Table('Customer')]
  [Id('FIdCustomer', TIdGenerator.IdentityOrSequence)]
  TCustomer = class
  private
    [Column('IdCustomer', [TColumnProp.Required])]
    FIdCustomer: integer;

    [Column('FullName', [TColumnProp.Required], 200)]
    FFullName: string;

    [Column('Company', [], 200)]
    FCompany: Nullable<string>;

    [Column('RUC', [], 10)]
    FRUC: Nullable<string>;

    [Column('Email', [], 200)]
    FEmail: Nullable<string>;

    [Column('Phone', [], 25)]
    FPhone: Nullable<string>;

    [Column('SupportWhatsapp', [], 1)]
    FSupportWhatsapp: Boolean;

    [Column('Address', [], 25)]
    FAddress: Nullable<string>;

    [Column('City', [], 100)]
    FCity: Nullable<string>;

    [Column('Country', [], 100)]
    FCountry: Nullable<string>;

  // Este no estoy seguro de esta implementacion
  {  [ForeignKey('FK_Customer2Store')]
    [JoinColumn('IdStore', [TColumnProp.Lazy, TColumnProp.Required])]
    FStore: TStore;}

  public
    property IdCustomer: integer read FIdCustomer write FIdCustomer;
    property FullName: string read FFullName write FFullName;
    property Company: Nullable<string> read FCompany write FCompany;
    property RUC: Nullable<string> read FRUC write FRUC;
    property Email: Nullable<string> read FEmail write FEmail;
    property Phone: Nullable<string> read FPhone write FPhone;
    property SupportWhatsapp: Boolean read FSupportWhatsapp write FSupportWhatsapp;
    property Address: Nullable<string> read FAddress write FAddress;
    property City: Nullable<string> read FCity write FCity;
    property Country: Nullable<string> read FCountry write FCountry;
 //   property Store: TStore read FStore write FStore;
  end;


  // Usuarios asociados a un customer (Cliente final) determinado
  [Entity, Automapping]
  [Table('CustomerUser')]
  [Id('FIdCustomerUser', TIdGenerator.IdentityOrSequence)]
  TCustomerUser = class
  private
    [Column('IdCustomerUser', [TColumnProp.Required])]
    FIdCustomerUser: integer;

    [ForeignKey('FK_CustomerUser2Customer')]
    [JoinColumn('IdCustomer', [TColumnProp.Lazy, TColumnProp.Required])]
    FCustomer: TCustomer;

    [ForeignKey('FK_CustomerUser2User')]
    [JoinColumn('IdUser', [TColumnProp.Lazy, TColumnProp.Required])]
    FUser: TUser;
  public
    property IdCustomerUser: integer read FIdCustomerUser write FIdCustomerUser;
    property Customer: TCustomer read FCustomer write FCustomer;
    property User: TUser read FUser write FUser;
  end;


implementation


initialization
  RegisterEntity(TCustomer);
  RegisterEntity(TCustomerUser);
end.
