unit uObjectDataLab;

interface

uses
  System.SysUtils, System.Classes, System.Generics.Collections, Data.DB, System.Variants,
  Bcl.Logging, TMSLoggingCore, TMSLoggingUtils,

  {$IFDEF MSWINDOWS}
  TMSLoggingMemoOutputHandler,
  {$ENDIF}

  Aurelius.Bind.BaseDataset, Aurelius.Bind.Dataset, Aurelius.Types.Nullable,
  Aurelius.Engine.ObjectManager, Aurelius.Drivers.Interfaces, Aurelius.Engine.DatabaseManager,
  Aurelius.Comp.Connection, Aurelius.Criteria.Base, Aurelius.Criteria.Linq,

  {$IFDEF WEB}
  UniFSToast,
  {$ENDIF}

  MemDS;

type
  TObjectDataLab = class(TDataModule)
    adsProductList: TAureliusDataset;
    dsProductList: TDataSource;
    adsProductListSelf: TAureliusEntityField;
    adsProductListIdProduct: TIntegerField;
    adsProductListFrontText: TStringField;
    adsProduct: TAureliusDataset;
    adsProductSelf: TAureliusEntityField;
    adsProductIdProduct: TIntegerField;
    adsProductTitle: TStringField;
    adsProductSubtitle: TStringField;
    adsProductDescription: TStringField;
    adsProductStatusProduct: TIntegerField;
    adsProductStore: TAureliusEntityField;
    adsProductTypeProduct: TAureliusEntityField;
    adsProductFrontText: TWideStringField;
    adsProductNorma: TStringField;
    adsProductAcreditacion: TBooleanField;
    adsProductAcreditacionOrganismo: TStringField;
    adsProductAcreditacionFecha: TDateField;
    adsProductAcreditacionVencimiento: TDateField;
    adsProductEstimatedTerm: TStringField;
    adsProductMemo: TStringField;
    adsProductProductAttached: TDataSetField;
    dsProduct: TDataSource;
    adsProductStoreName: TStringField;
    adsProductTypeProductTypeProduct: TStringField;
    adsProductStoreLogo: TBlobField;
    adsNewOrder: TAureliusDataset;
    adsNewOrderSelf: TAureliusEntityField;
    adsNewOrderDateTime: TDateTimeField;
    adsNewOrderStatusOrder: TIntegerField;
    adsNewOrderStore: TAureliusEntityField;
    adsNewOrderCustomer: TAureliusEntityField;
    adsNewOrderDeliverMethod: TAureliusEntityField;
    adsNewOrderUser: TAureliusEntityField;
    adsNewOrderItems: TDataSetField;
    adsItem: TAureliusDataset;
    dsNewOrder: TDataSource;
    dsItems: TDataSource;
    adsItemSelf: TAureliusEntityField;
    adsItemIdItem: TIntegerField;
    adsItemProduct: TAureliusEntityField;
    adsItemQuantity: TFloatField;
    adsItemUnitPrice: TCurrencyField;
    adsNewOrderStoreName: TStringField;
    adsNewOrderStorePhone: TStringField;
    adsNewOrderStoreWhatsapp: TStringField;
    adsNewOrderStoreEmail: TStringField;
    adsNewOrderStoreLogo: TBlobField;
    adsProductStoreAddress: TStringField;
    adsNewOrderStoreAddress: TStringField;
    adsProductStorePhone: TStringField;
    adsProductStoreWhatsapp: TStringField;
    adsProductStoreEmail: TStringField;
    adsCustomer: TAureliusDataset;
    adsCustomerSelf: TAureliusEntityField;
    adsCustomerIdCustomer: TIntegerField;
    adsCustomerFullName: TStringField;
    adsCustomerCompany: TStringField;
    adsCustomerRUC: TStringField;
    adsCustomerEmail: TStringField;
    adsCustomerPhone: TStringField;
    adsCustomerSupportWhatsapp: TBooleanField;
    adsCustomerAddress: TStringField;
    adsCustomerCity: TStringField;
    adsCustomerCountry: TStringField;
    adsNewOrderCustomerIdCustomer: TIntegerField;
    adsNewOrderCustomerFullName: TStringField;
    adsNewOrderCustomerCompany: TStringField;
    adsNewOrderCustomerRUC: TStringField;
    adsNewOrderCustomerEmail: TStringField;
    adsNewOrderCustomerPhone: TStringField;
    adsNewOrderCustomerAddress: TStringField;
    adsNewOrderCustomerCity: TStringField;
    adsNewOrderCustomerCountry: TStringField;
    adsItemProductTitle: TStringField;
    adsItemProductSubtitle: TStringField;
    adsNewOrderIdOrderMaster: TIntegerField;
    adsNewOrderMemo: TStringField;
    adsItemProductIdProduct: TIntegerField;
    adsTypeProduct: TAureliusDataset;
    adsTypeProductSelf: TAureliusEntityField;
    adsTypeProductIdTypeProduct: TIntegerField;
    adsTypeProductTypeProduct: TStringField;
    dsTypeProduct: TDataSource;
    adsPaymentMethod: TAureliusDataset;
    adsPaymentMethodSelf: TAureliusEntityField;
    adsPaymentMethodIdPaymentMethod: TIntegerField;
    adsPaymentMethodPaymentMethod: TStringField;
    dsPaymentMethod: TDataSource;
    adsDeliverMethod: TAureliusDataset;
    adsDeliverMethodSelf: TAureliusEntityField;
    adsDeliverMethodIdDeliverMethod: TIntegerField;
    adsDeliverMethodDeliverMethod: TStringField;
    dsDeliverMethod: TDataSource;
    adsItemTotal: TCurrencyField;
    adsProductPrice: TCurrencyField;
    adsPayment: TAureliusDataset;
    adsPaymentSelf: TAureliusEntityField;
    adsPaymentIdPayment: TIntegerField;
    adsPaymentOrderMaster: TAureliusEntityField;
    adsPaymentPaymentMethod: TAureliusEntityField;
    adsPaymentAmount: TCurrencyField;
    dsPayment: TDataSource;
    adsOrder: TAureliusDataset;
    dsOrder: TDataSource;
    adsOrderSelf: TAureliusEntityField;
    adsOrderIdOrderMaster: TIntegerField;
    adsOrderDateTime: TDateTimeField;
    adsOrderStatusOrder: TIntegerField;
    adsOrderStore: TAureliusEntityField;
    adsOrderCustomer: TAureliusEntityField;
    adsOrderUser: TAureliusEntityField;
    adsOrderDeliverMethod: TAureliusEntityField;
    adsOrderMemo: TStringField;
    adsOrderPickupLabTechDate: TDateTimeField;
    adsOrderPickupLabTechTime: TStringField;
    adsOrderPickupLabTechAddress: TStringField;
    adsOrderPickupDeliveryDate: TDateTimeField;
    adsOrderPickupDeliveryTime: TStringField;
    adsOrderPickupDeliveryAddress: TStringField;
    adsOrderItems: TDataSetField;
    adsOrderStoreShortName: TStringField;
    adsOrderCustomerFullName: TStringField;
    adsOrderCustomerRUC: TStringField;
    adsOrderStatusOrderEnumName: TStringField;
    adsOrderTypeProduct: TAureliusEntityField;
    adsOrderTotalOrder: TCurrencyField;
    adsOrderTypeProductTypeProduct: TStringField;
    adsStore: TAureliusDataset;
    dsStore: TDataSource;
    adsStoreSelf: TAureliusEntityField;
    adsStoreIdStore: TIntegerField;
    adsStoreName: TStringField;
    adsStoreShortName: TStringField;
    adsStoreLogo: TBlobField;
    adsStoreAddress: TStringField;
    adsStorePhone: TStringField;
    adsStoreWhatsapp: TStringField;
    adsStoreEmail: TStringField;
    adsStoreSlogan: TStringField;
    adsStoreRUC: TStringField;
    adsStoreContactName: TStringField;
    adsStoreContactEmail: TStringField;
    adsStoreContactPhone: TStringField;
    adsStoreAccountNumber: TStringField;
    adsProductStoreShortName: TStringField;
    adsProductListMetodologiaEnsayo: TStringField;
    adsProductMetodologiaEnsayo: TStringField;
    adsProductEquipoEnsayo: TStringField;
    adsMatrizProduct: TAureliusDataset;
    adsMatrizProductSelf: TAureliusEntityField;
    adsMatrizProductIdMatrizProduct: TIntegerField;
    adsMatrizProductMatrizProduct: TStringField;
    adsMatrizProductStore: TAureliusEntityField;
    dsMatrizProduct: TDataSource;
    adsProductMatrizProduct: TAureliusEntityField;
    adsNewOrderPickupLabTechDateFrom: TDateField;
    adsNewOrderPickupLabTechDateTo: TDateField;
    adsNewOrderPickupLabTechTimeFrom: TTimeField;
    adsNewOrderPickupLabTechTimeTo: TTimeField;
    adsNewOrderPickupLabTechAddress: TStringField;
    adsNewOrderPickupDeliveryDate: TDateField;
    adsNewOrderPickupDeliveryTimeFrom: TTimeField;
    adsNewOrderPickupDeliveryTimeTo: TTimeField;
    adsNewOrderPickupDeliveryAddress: TStringField;
    adsNewOrderPickupDeliveryInstructions: TStringField;
    adsNewOrderTypeProduct: TAureliusEntityField;
    adsNewOrderTotalOrder: TCurrencyField;
    adsNewOrderDeliverMethodIdDeliverMethod: TIntegerField;
    adsNewOrderDeliverMethodDeliverMethod: TStringField;
    adsProductStoreIdStore: TIntegerField;
    adsStoreLatitude: TFloatField;
    adsStoreLongitude: TFloatField;
    dsCustomer: TDataSource;
    adsStoreStorePhoto: TDataSetField;
    adsStoreStoreAcreditacion: TDataSetField;
    procedure adsNewOrderNewRecord(DataSet: TDataSet);
    procedure adsNewOrderObjectInsert(Dataset: TDataSet; AObject: TObject);
    procedure adsStoreObjectUpdate(Dataset: TDataSet; AObject: TObject);
    procedure adsStoreObjectInsert(Dataset: TDataSet; AObject: TObject);
    procedure DataModuleCreate(Sender: TObject);
    procedure adsProductObjectInsert(Dataset: TDataSet; AObject: TObject);
    procedure adsProductObjectUpdate(Dataset: TDataSet; AObject: TObject);
    procedure adsProductObjectRemove(Dataset: TDataSet; AObject: TObject);
    procedure adsPaymentObjectInsert(Dataset: TDataSet; AObject: TObject);
    procedure adsPaymentObjectUpdate(Dataset: TDataSet; AObject: TObject);
  private
    function GetLogger: ILogger;
  public
    Manager: TObjectManager;


    function GetManager: TObjectManager;
    property Logger: ILogger read GetLogger;
  end;

  var ObjectDataLab: TObjectDataLab;


implementation

uses
  //uServerSettings,
  uConnectionModule, uCustomer, uOrder, uPayment, //uObjectDataUser,
  uStore, uUser;// uCodeDatabase, uCodeCommon, uResourceStringLab;


{$R *.dfm}


procedure TObjectDataLab.adsNewOrderNewRecord(DataSet: TDataSet);
begin
  adsNewOrderDateTime.Value := Now;

  // Pendiente
  adsNewOrderStatusOrder.Value := 1;
end;


procedure TObjectDataLab.adsNewOrderObjectInsert(Dataset: TDataSet;
  AObject: TObject);
begin
  Manager.Save(AObject);
end;


procedure TObjectDataLab.adsPaymentObjectInsert(Dataset: TDataSet;
  AObject: TObject);
begin
  Manager.Save(AObject);
end;


procedure TObjectDataLab.adsPaymentObjectUpdate(Dataset: TDataSet;
  AObject: TObject);
begin
//  Manager.Save(AObject);
end;


procedure TObjectDataLab.adsProductObjectInsert(Dataset: TDataSet;
  AObject: TObject);
begin
  Manager.Save(AObject);
end;


procedure TObjectDataLab.adsProductObjectRemove(Dataset: TDataSet;
  AObject: TObject);
begin
  Manager.Remove(AObject);
end;


procedure TObjectDataLab.adsProductObjectUpdate(Dataset: TDataSet;
  AObject: TObject);
begin
  Manager.Update(AObject);
end;


procedure TObjectDataLab.adsStoreObjectInsert(Dataset: TDataSet;
  AObject: TObject);
begin
  Manager.Save(AObject);
end;


procedure TObjectDataLab.adsStoreObjectUpdate(Dataset: TDataSet;
  AObject: TObject);
begin
  Manager.Update(AObject);
end;


procedure TObjectDataLab.DataModuleCreate(Sender: TObject);
begin
//  TDataModuleUtils.FormatCurrency([adsProduct]);
end;


function TObjectDataLab.GetLogger: ILogger;
begin
  Result := LogManager.GetLogger;
end;


function TObjectDataLab.GetManager: TObjectManager;
var
  ConnectionDB: IDBConnection;
begin
  // Creo el objeto de las bases de datos
  ConnectionDB := uConnectionModule.DatabaseConnection.AureliusConnection.CreateConnection;
  Result := TObjectManager.Create(ConnectionDB);
end;


end.
