unit uPayment;

interface

uses
  System.Classes, System.StrUtils, System.DateUtils, Generics.Collections,
  Bcl.Validation.Attributes, Bcl.Validation.Classes, Aurelius.Types.Blob,
  Aurelius.Types.Nullable, Aurelius.Types.Proxy, Aurelius.Mapping.Attributes,

  // Entidades
  uOrder,

  System.Variants;// uTipoConstante;

{const
  cPaymentMethod: array[0..3] of TIRegistro =
  (
    (Id: 1; Descripcion: 'Pago en ventanilla'),
    (Id: 2; Descripcion: 'Transferencia o depsito bancario'),
    (Id: 3; Descripcion: 'Pago mvil / Red Infonet'),
    (Id: 4; Descripcion: 'Redes de cobranzas Aqui Pago')
  );}

type
  [Entity, Automapping]
  [Table('PaymentMethod')]
  [Id('FIdPaymentMethod', TIdGenerator.None)]
  TPaymentMethod = class
  private
    [Column('IdPaymentMethod', [TColumnProp.Required])]
    FIdPaymentMethod: integer;

    [Column('PaymentMethod', [TColumnProp.Required, TColumnProp.Unique], 100)]
    FPaymentMethod: string;
  public
    property IdPaymentMethod: integer read FIdPaymentMethod write FIdPaymentMethod;
    property PaymentMethod: string read FPaymentMethod write FPaymentMethod;
  end;


  [Entity, Automapping]
  [Table('Payment')]
  [Id('FIdPayment', TIdGenerator.IdentityOrSequence)]
  TPayment = class
  private
    [Column('IdFIdPayment', [TColumnProp.Required])]
    FIdPayment: integer;

    [ForeignKey('FK_Payment2Order')]
    [JoinColumn('IdOrderMaster', [TColumnProp.Lazy, TColumnProp.Required])]
    FOrderMaster: TOrderMaster;

    [ForeignKey('FK_Payment2PaymentMethod')]
    [JoinColumn('IdPaymentMethod', [TColumnProp.Lazy, TColumnProp.Required])]
    FPaymentMethod: TPaymentMethod;

    [Column('Amount', [TColumnProp.Required])]
    FAmount: Currency;

  public
    property IdPayment: integer read FIdPayment write FIdPayment;
    property OrderMaster: TOrderMaster read FOrderMaster write FOrderMaster;
    property PaymentMethod: TPaymentMethod read FPaymentMethod write FPaymentMethod;
    property Amount: Currency read FAmount write FAmount;
  end;


implementation


initialization
  RegisterEntity(TPaymentMethod);
  RegisterEntity(TPayment);

end.
