unit uUser;

interface

uses
  System.Classes, System.StrUtils, System.DateUtils, Generics.Collections,
  Bcl.Validation.Attributes, Bcl.Validation.Classes, Aurelius.Types.Blob,
  Aurelius.Types.Nullable, Aurelius.Types.Proxy, Aurelius.Mapping.Attributes;

type
  [Enumeration(TEnumMappingType.emChar, 'A,N,S')]
  TUserProfile = (Administrador, Normal, SoloLectura);

  [Entity, Automapping]
  {$IF DEFINED(NEX)}
  [Table('Usuario')]
  {$ENDIF}

  {$IF DEFINED(LAB)}
  [Table('User_')]
  {$ENDIF}
  [Id('FIdUser', TIdGenerator.IdentityOrSequence)]
  TUser = class
  private
    {$IF DEFINED(NEX)}
    [Column('IdUsuario', [TColumnProp.Required])]
    {$ENDIF}

    {$IF DEFINED(LAB)}
    [Column('IdUser', [TColumnProp.Required])]
    {$ENDIF}
    FIdUser: integer;

    {$IF DEFINED(NEX)}
    [Column('Usuario', [TColumnProp.Required, TColumnProp.Unique], 50)]
    {$ENDIF}

    {$IF DEFINED(LAB)}
    [Column('Username', [TColumnProp.Required], 100)]
    {$ENDIF}
    FUsername: string;

    {$IF DEFINED(NEX)}
    [Column('Contrasena', [TColumnProp.Required], 200)]
    {$ENDIF}

    {$IF DEFINED(LAB)}
    [Column('Password_', [TColumnProp.Required], 200)]
    {$ENDIF}
    FPassword: string;

    {$IF DEFINED(NEX)}
    [Column('Nombre', [TColumnProp.Required], 100)]
    {$ENDIF}

    {$IF DEFINED(LAB)}
    [Column('Name', [TColumnProp.Required], 100)]
    {$ENDIF}
    [Required, MaxLength(100)]
    FName: string;

    [Column('Email', [], 200)]
    [EmailAddress('Email proporcionado no es vlido')]
    FEmail: Nullable<string>;

    {$IF DEFINED(NEX)}
    [Column('Perfil', [], 1)]
    {$ENDIF}

    {$IF DEFINED(LAB)}
    [Column('UserProfile', [], 1)]
    {$ENDIF}
    FUserProfile: TUserProfile;
  public
    property IdUser: integer read FIdUser write FIdUser;
    property Username: string read FUsername write FUsername;
    property Password: string read FPassword write FPassword;
    property Name: string read FName write FName;
    property Email: Nullable<string> read FEmail write FEmail;
    property UserProfile: TUserProfile read FUserProfile write FUserProfile;
  end;

implementation


initialization
  RegisterEntity(TUser);
end.

